<?php
/**
 * @package ats
 * @copyright Copyright (c)2011-2018 Nicholas K. Dionysopoulos / Akeeba Ltd
 * @license GNU GPL v3 or later
 */

/** @var $this \Akeeba\TicketSystem\Admin\View\Tickets\Html */
use Akeeba\TicketSystem\Admin\Helper\Select;

defined('_JEXEC') or die;

// Joomla! 3.6: If you have behavior.modal AND a user select on the same page the user selection breaks
if (version_compare(JVERSION, '3.6', 'lt'))
{
    JHtml::_('behavior.modal');
}

$container = $this->getContainer();
$tags      = array();

if($this->item->created_by)
{
	// First fetch the tags from the legacy storage
	// TODO This will be removed in future versions when we completed the migration of the tags
    /** @var \Akeeba\TicketSystem\Admin\Model\UserTags $usertags */
    $usertags = $container->factory->model('UserTags')->tmpInstance();
    $tags     = $usertags->loadTagsByUser($this->item->created_by);

	// Then merge them with the new way
	/** @var \Akeeba\TicketSystem\Admin\Model\JoomlaUsers $joomlaModel */
	$joomlaModel = $this->getModel('JoomlaUsers');
	$joomlaModel->find($this->item->created_by);

	/** @var \FOF30\Model\DataModel\Collection $collection */
	$collection = $joomlaModel->atstags;
	$tags = array_merge($tags, $collection->modelKeys());
	$tags = array_unique($tags);
}

?>
<div class="control-group">
    <label class="control-label"><?php echo JText::_('COM_ATS_COMMON_USERSELECT_LBL')?></label>
    <div class="controls">
	    <?php echo \Akeeba\TicketSystem\Admin\Helper\Html::modalChooseUser('created_by', 'created_by', $this->item->created_by)?>
    </div>
</div>
<div class="control-group">
    <label class="control-label"><?php echo JText::_('COM_ATS_COMMON_USER_TAGS')?></label>
    <div class="controls">
        <?php echo Select::usertags('usertags[]', $tags, array('class' => 'advancedSelect', 'multiple' => 'multiple', 'size' => 5))?>
    </div>
</div>
